'use strict';

var _get = require('babel-runtime/helpers/get')['default'];

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _extends = require('babel-runtime/helpers/extends')['default'];

var _Object$keys = require('babel-runtime/core-js/object/keys')['default'];

var _interopRequireDefault = require('babel-runtime/helpers/interop-require-default')['default'];

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _state = require('./state');

var _state2 = _interopRequireDefault(_state);

var _throwError = require('./throw-error');

var _throwError2 = _interopRequireDefault(_throwError);

exports['default'] = function (dataFactory) {
    return function (Component) {
        return (function (_React$Component) {
            _inherits(DataWatcher, _React$Component);

            _createClass(DataWatcher, null, [{
                key: 'contextTypes',
                value: {
                    state: _react2['default'].PropTypes.instanceOf(_state2['default'])
                },
                enumerable: true
            }]);

            function DataWatcher(props, context) {
                _classCallCheck(this, DataWatcher);

                _get(Object.getPrototypeOf(DataWatcher.prototype), 'constructor', this).call(this, props, context);

                this.cursors = {};
                this.dataState = context.state;

                if (typeof this.dataState === 'undefined') {
                    (0, _throwError2['default'])('missing state. It can happen if you forgot to set state in DataInit\n                        or using any decorator before DataInit', this.constructor.displayName);
                }

                this._initCursors(props);

                this.state = _extends({}, this.state, {
                    data: this._getCurrentData()
                });

                this._updateDataState = this._updateDataState.bind(this);
            }

            _createClass(DataWatcher, [{
                key: 'componentDidMount',
                value: function componentDidMount() {
                    var _this = this;

                    _Object$keys(this.cursors).forEach(function (branch) {
                        _this.dataState._addToWatchingQueue(_this.cursors[branch].path);
                    });

                    this._updateDataState();
                    this._dataWatch();
                }
            }, {
                key: 'componentWillReceiveProps',
                value: function componentWillReceiveProps(nextProps) {
                    if (this._isChangedProps(nextProps)) {
                        this._reloadComponentData(nextProps);
                    }
                }
            }, {
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    var _this2 = this;

                    _Object$keys(this.cursors).forEach(function (branch) {
                        _this2.dataState._removeFromWatchingQueue(_this2.cursors[branch].path);
                    });

                    this._dataUnwatch();
                }
            }, {
                key: '_isChangedProps',
                value: function _isChangedProps(nextProps) {
                    var _this3 = this;

                    return _Object$keys(nextProps).some(function (key) {
                        return nextProps[key] !== _this3.props[key];
                    });
                }
            }, {
                key: '_reloadComponentData',
                value: function _reloadComponentData() {
                    var props = arguments.length <= 0 || arguments[0] === undefined ? this.props : arguments[0];

                    this._dataUnwatch();
                    this._initCursors(props);
                    this._updateDataState();
                    this._dataWatch();
                }
            }, {
                key: '_reloadComponentDataFromPath',
                value: function _reloadComponentDataFromPath() {
                    this._reloadComponentData();
                }
            }, {
                key: '_isValidObjectPathChunk',
                value: function _isValidObjectPathChunk(pathChunk) {
                    var _this4 = this;

                    return _Object$keys(pathChunk).every(function (key) {
                        return _this4._isValidPathChunk(pathChunk[key]);
                    });
                }
            }, {
                key: '_isValidPathChunk',
                value: function _isValidPathChunk(pathChunk) {
                    return typeof pathChunk !== 'undefined';
                }
            }, {
                key: '_isValidPath',
                value: function _isValidPath(path) {
                    var _this5 = this;

                    return path.length !== 0 && path.every(function (pathChunk) {
                        if (typeof pathChunk === 'object') {
                            return _this5._isValidObjectPathChunk(pathChunk);
                        }

                        return _this5._isValidPathChunk(pathChunk);
                    });
                }
            }, {
                key: '_prepareArrayPathChunk',
                value: function _prepareArrayPathChunk(pathChunk) {
                    var _this6 = this;

                    var stateTree = this.dataState.getTree();
                    var preparedCursorPath = this._prepareCursorPath(pathChunk);

                    if (!this._isValidPath(preparedCursorPath)) {
                        return;
                    }

                    var pathChunkCursor = stateTree.select(preparedCursorPath);
                    var shouldListenForUpdate = pathChunkCursor.listeners('update').every(function (listener) {
                        return listener.scope !== _this6;
                    });

                    if (shouldListenForUpdate) {
                        pathChunkCursor.on('update', this._reloadComponentDataFromPath, {
                            scope: this
                        });
                    }

                    return pathChunkCursor.get();
                }
            }, {
                key: '_prepareObjectPathChunk',
                value: function _prepareObjectPathChunk(pathChunk) {
                    var _this7 = this;

                    var preparedPathChunk = {};

                    _Object$keys(pathChunk).forEach(function (key) {
                        preparedPathChunk[key] = _this7._preparePathChunk(pathChunk[key]);
                    });

                    return preparedPathChunk;
                }
            }, {
                key: '_preparePathChunk',
                value: function _preparePathChunk(pathChunk) {
                    if (Array.isArray(pathChunk)) {
                        return this._prepareArrayPathChunk(pathChunk);
                    } else if (typeof pathChunk === 'object') {
                        return this._prepareObjectPathChunk(pathChunk);
                    }

                    return pathChunk;
                }
            }, {
                key: '_prepareCursorPath',
                value: function _prepareCursorPath(path) {
                    return path.map(this._preparePathChunk.bind(this));
                }
            }, {
                key: '_prepareCursorPaths',
                value: function _prepareCursorPaths(props) {
                    var _this8 = this;

                    var cursorPaths = dataFactory(props);

                    _Object$keys(cursorPaths).forEach(function (branch) {
                        cursorPaths[branch] = _this8._prepareCursorPath(cursorPaths[branch]);
                    });

                    return cursorPaths;
                }
            }, {
                key: '_initCursors',
                value: function _initCursors(props) {
                    var _this9 = this;

                    var stateTree = this.dataState.getTree();

                    this.cursorPaths = this._prepareCursorPaths(props);

                    _Object$keys(this.cursorPaths).filter(function (branch) {
                        return _this9._isValidPath(_this9.cursorPaths[branch]);
                    }).forEach(function (branch) {
                        _this9.cursors[branch] = stateTree.select(_this9.cursorPaths[branch]);
                    });
                }
            }, {
                key: '_dataWatch',
                value: function _dataWatch() {
                    var _this10 = this;

                    _Object$keys(this.cursors).forEach(function (cursorType) {
                        return _this10.cursors[cursorType].on('update', _this10._updateDataState);
                    });
                }
            }, {
                key: '_dataUnwatch',
                value: function _dataUnwatch() {
                    var _this11 = this;

                    _Object$keys(this.cursors).forEach(function (cursorType) {
                        return _this11.cursors[cursorType].off('update', _this11._updateDataState);
                    });
                }
            }, {
                key: '_getCurrentData',
                value: function _getCurrentData() {
                    var _this12 = this;

                    var data = {};

                    _Object$keys(this.cursors).forEach(function (branch) {
                        data[branch] = _this12.cursors[branch].get();
                    });

                    return data;
                }
            }, {
                key: '_updateDataState',
                value: function _updateDataState() {
                    this.setState({
                        data: this._getCurrentData()
                    });
                }
            }, {
                key: 'render',
                value: function render() {
                    return _react2['default'].createElement(Component, _extends({}, this.props, this.state.data), this.props.children);
                }
            }]);

            return DataWatcher;
        })(_react2['default'].Component);
    };
};

module.exports = exports['default'];